diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/avpair.c tomato121/release/src/router/pppd/pppd/plugins/radius/avpair.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/avpair.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/avpair.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,795 @@
+/*
+ * $Id: avpair.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+
+static void rc_extract_vendor_specific_attributes(int attrlen,
+						  unsigned char *ptr,
+						  VALUE_PAIR **vp);
+/*
+ * Function: rc_avpair_add
+ *
+ * Purpose: add an attribute-value pair to the given list.
+ *
+ * Returns: pointer to added a/v pair upon success, NULL pointer upon failure.
+ *
+ * Remarks: Always appends the new pair to the end of the list.
+ *
+ */
+
+VALUE_PAIR *rc_avpair_add (VALUE_PAIR **list, int attrid, void *pval, int len,
+			   int vendorcode)
+{
+	VALUE_PAIR     *vp;
+
+	vp = rc_avpair_new (attrid, pval, len, vendorcode);
+
+	if (vp != (VALUE_PAIR *) NULL)
+	{
+		rc_avpair_insert (list, (VALUE_PAIR *) NULL, vp);
+	}
+
+	return vp;
+
+}
+
+/*
+ * Function: rc_avpair_assign
+ *
+ * Purpose: assign the given value to an attribute-value pair.
+ *
+ * Returns:  0 on success,
+ *	    -1 on failure.
+ *
+ */
+
+int rc_avpair_assign (VALUE_PAIR *vp, void *pval, int len)
+{
+	int	result = -1;
+
+	switch (vp->type)
+	{
+		case PW_TYPE_STRING:
+
+			if (((len == 0) && (strlen ((char *) pval)) > AUTH_STRING_LEN)
+			    || (len > AUTH_STRING_LEN)) {
+				error("rc_avpair_assign: bad attribute length");
+				return result;
+		    }
+
+			if (len > 0) {
+				memcpy(vp->strvalue, (char *)pval, len);
+				vp->strvalue[len] = '\0';
+				vp->lvalue = len;
+			} else {
+			strncpy (vp->strvalue, (char *) pval, AUTH_STRING_LEN);
+			vp->lvalue = strlen((char *) pval);
+			}
+
+			result = 0;
+			break;
+
+		case PW_TYPE_DATE:
+		case PW_TYPE_INTEGER:
+		case PW_TYPE_IPADDR:
+
+			vp->lvalue = * (UINT4 *) pval;
+
+			result = 0;
+			break;
+
+		default:
+			error("rc_avpair_assign: unknown attribute %d", vp->type);
+	}
+	return result;
+}
+
+/*
+ * Function: rc_avpair_new
+ *
+ * Purpose: make a new attribute-value pair with given parameters.
+ *
+ * Returns: pointer to generated a/v pair when successful, NULL when failure.
+ *
+ */
+
+VALUE_PAIR *rc_avpair_new (int attrid, void *pval, int len, int vendorcode)
+{
+	VALUE_PAIR     *vp = (VALUE_PAIR *) NULL;
+	DICT_ATTR      *pda;
+
+	if ((pda = rc_dict_getattr (attrid, vendorcode)) == (DICT_ATTR *) NULL)
+	{
+		error("rc_avpair_new: unknown attribute %d", attrid);
+	}
+	else
+	{
+		if ((vp = (VALUE_PAIR *) malloc (sizeof (VALUE_PAIR)))
+							!= (VALUE_PAIR *) NULL)
+		{
+			strncpy (vp->name, pda->name, sizeof (vp->name));
+			vp->attribute = attrid;
+			vp->vendorcode = vendorcode;
+			vp->next = (VALUE_PAIR *) NULL;
+			vp->type = pda->type;
+			if (rc_avpair_assign (vp, pval, len) == 0)
+			{
+				return vp;
+			}
+			free (vp);
+			vp = (VALUE_PAIR *) NULL;
+		}
+		else
+			novm("rc_avpair_new");
+	}
+	return vp;
+}
+
+/*
+ *
+ * Function: rc_avpair_gen
+ *
+ * Purpose: takes attribute/value pairs from buffer and builds a
+ *	    value_pair list using allocated memory.
+ *
+ * Returns: value_pair list or NULL on failure
+ */
+
+VALUE_PAIR *rc_avpair_gen (AUTH_HDR *auth)
+{
+	int             length;
+	int             x_len;
+	int             attribute;
+	int             attrlen;
+	UINT4           lvalue;
+	unsigned char         *x_ptr;
+	unsigned char         *ptr;
+	DICT_ATTR      *attr;
+	VALUE_PAIR     *vp;
+	VALUE_PAIR     *pair;
+	unsigned char   hex[3];		/* For hex string conversion. */
+	char            buffer[512];
+
+	/*
+	 * Extract attribute-value pairs
+	 */
+	ptr = auth->data;
+	length = ntohs ((unsigned short) auth->length) - AUTH_HDR_LEN;
+	vp = (VALUE_PAIR *) NULL;
+
+	while (length > 0)
+	{
+		attribute = *ptr++;
+		attrlen = *ptr++;
+		attrlen -= 2;
+		if (attrlen < 0)
+		{
+			error("rc_avpair_gen: received attribute with invalid length");
+			break;
+		}
+
+		/* Handle vendor-specific specially */
+		if (attribute == PW_VENDOR_SPECIFIC) {
+		    rc_extract_vendor_specific_attributes(attrlen, ptr, &vp);
+		    ptr += attrlen;
+		    length -= (attrlen + 2);
+		    continue;
+		}
+		if ((attr = rc_dict_getattr (attribute, VENDOR_NONE)) == (DICT_ATTR *) NULL)
+		{
+			*buffer= '\0';	/* Initial length. */
+			for (x_ptr = ptr, x_len = attrlen ;
+				x_len > 0 ;
+				x_len--, x_ptr++)
+			{
+				sprintf (hex, "%2.2X", *x_ptr);
+				strcat (buffer, hex);
+			}
+			warn("rc_avpair_gen: received unknown attribute %d of length %d: 0x%s",
+				attribute, attrlen, buffer);
+		}
+		else
+		{
+			if ((pair =
+				(VALUE_PAIR *) malloc (sizeof (VALUE_PAIR))) ==
+					(VALUE_PAIR *) NULL)
+			{
+				novm("rc_avpair_gen");
+				rc_avpair_free(vp);
+				return NULL;
+			}
+			strcpy (pair->name, attr->name);
+			pair->attribute = attr->value;
+			pair->vendorcode = VENDOR_NONE;
+			pair->type = attr->type;
+			pair->next = (VALUE_PAIR *) NULL;
+
+			switch (attr->type)
+			{
+
+			    case PW_TYPE_STRING:
+				memcpy (pair->strvalue, (char *) ptr, (size_t) attrlen);
+				pair->strvalue[attrlen] = '\0';
+				pair->lvalue = attrlen;
+				rc_avpair_insert (&vp, (VALUE_PAIR *) NULL, pair);
+				break;
+
+			    case PW_TYPE_INTEGER:
+			    case PW_TYPE_IPADDR:
+				memcpy ((char *) &lvalue, (char *) ptr,
+					sizeof (UINT4));
+				pair->lvalue = ntohl (lvalue);
+				rc_avpair_insert (&vp, (VALUE_PAIR *) NULL, pair);
+				break;
+
+			    default:
+				warn("rc_avpair_gen: %s has unknown type", attr->name);
+				free (pair);
+				break;
+			}
+
+		}
+		ptr += attrlen;
+		length -= attrlen + 2;
+	}
+	return (vp);
+}
+
+/*
+ * Function: rc_extract_vendor_specific_attributes
+ *
+ * Purpose: Extracts vendor-specific attributes, assuming they are in
+ *          the "SHOULD" format recommended by RCF 2138.
+ *
+ * Returns: found value_pair
+ *
+ */
+static void rc_extract_vendor_specific_attributes(int attrlen,
+						  unsigned char *ptr,
+						  VALUE_PAIR **vp)
+{
+    int vendor_id;
+    int vtype;
+    int vlen;
+    UINT4 lvalue;
+    DICT_ATTR *attr;
+    VALUE_PAIR *pair;
+
+    /* ptr is sitting at vendor-ID */
+    if (attrlen < 8) {
+	/* Nothing to see here... */
+	return;
+    }
+
+    /* High-order octet of Vendor-Id must be zero (RFC2138) */
+    if (*ptr) {
+	return;
+    }
+
+    /* Extract vendor_id */
+    vendor_id = (int) (
+	((unsigned int) ptr[1]) * 256 * 256 +
+	((unsigned int) ptr[2]) * 256 +
+	((unsigned int) ptr[3]));
+    /* Bump ptr up to contents */
+    ptr += 4;
+
+    /* Set attrlen to length of data */
+    attrlen -= 4;
+    for (; attrlen; attrlen -= vlen+2, ptr += vlen) {
+	vtype = *ptr++;
+	vlen = *ptr++;
+	vlen -= 2;
+	if (vlen < 0 || vlen > attrlen - 2) {
+	    /* Do not log an error.  We are supposed to be able to cope with
+	       arbitrary vendor-specific gunk */
+	    return;
+	}
+	/* Looks plausible... */
+	if ((attr = rc_dict_getattr(vtype, vendor_id)) == NULL) {
+	    continue;
+	}
+
+	/* TODO: Check that length matches data size!!!!! */
+	pair = (VALUE_PAIR *) malloc(sizeof(VALUE_PAIR));
+	if (!pair) {
+	    novm("rc_avpair_gen");
+	    return;
+	}
+	strcpy(pair->name, attr->name);
+	pair->attribute = attr->value;
+	pair->vendorcode = vendor_id;
+	pair->type = attr->type;
+	pair->next = NULL;
+	switch (attr->type) {
+	case PW_TYPE_STRING:
+	    memcpy (pair->strvalue, (char *) ptr, (size_t) vlen);
+	    pair->strvalue[vlen] = '\0';
+	    pair->lvalue = vlen;
+	    rc_avpair_insert (vp, (VALUE_PAIR *) NULL, pair);
+	    break;
+
+	case PW_TYPE_INTEGER:
+	case PW_TYPE_IPADDR:
+	    memcpy ((char *) &lvalue, (char *) ptr,
+		    sizeof (UINT4));
+	    pair->lvalue = ntohl (lvalue);
+	    rc_avpair_insert (vp, (VALUE_PAIR *) NULL, pair);
+	    break;
+
+	default:
+	    warn("rc_avpair_gen: %s has unknown type", attr->name);
+	    free (pair);
+	    break;
+	}
+    }
+}
+
+/*
+ * Function: rc_avpair_get
+ *
+ * Purpose: Find the first attribute value-pair (which matches the given
+ *          attribute) from the specified value-pair list.
+ *
+ * Returns: found value_pair
+ *
+ */
+
+VALUE_PAIR *rc_avpair_get (VALUE_PAIR *vp, UINT4 attr)
+{
+	for (; vp != (VALUE_PAIR *) NULL && vp->attribute != attr; vp = vp->next)
+	{
+		continue;
+	}
+	return (vp);
+}
+
+/*
+ * Function: rc_avpair_copy
+ *
+ * Purpose: Return a copy of the existing list "p" ala strdup().
+ *
+ */
+VALUE_PAIR *rc_avpair_copy(VALUE_PAIR *p)
+{
+	VALUE_PAIR *vp, *fp = NULL, *lp = NULL;
+
+	while (p) {
+		vp = malloc(sizeof(VALUE_PAIR));
+		if (!vp) {
+		    novm("rc_avpair_copy");
+		    return NULL; /* leaks a little but so what */
+		}
+		*vp = *p;
+		if (!fp)
+			fp = vp;
+		if (lp)
+			lp->next = vp;
+		lp = vp;
+		p = p->next;
+	}
+
+	return fp;
+}
+
+/*
+ * Function: rc_avpair_insert
+ *
+ * Purpose: Given the address of an existing list "a" and a pointer
+ *	    to an entry "p" in that list, add the list "b" to
+ *	    the "a" list after the "p" entry.  If "p" is NULL, add
+ *	    the list "b" to the end of "a".
+ *
+ */
+
+void rc_avpair_insert (VALUE_PAIR **a, VALUE_PAIR *p, VALUE_PAIR *b)
+{
+	VALUE_PAIR     *this_node = NULL;
+	VALUE_PAIR     *vp;
+
+	if (*a == (VALUE_PAIR *) NULL)
+	{
+		*a = b;
+		return;
+	}
+
+	if (!b)
+		return;
+
+	vp = *a;
+
+	if ( p == (VALUE_PAIR *) NULL) /* run to end of "a" list */
+	{
+		while (vp != (VALUE_PAIR *) NULL)
+		{
+			this_node = vp;
+			vp = vp->next;
+		}
+	}
+	else /* look for the "p" entry in the "a" list (or run to end) */
+	{
+		this_node = *a;
+		while (this_node != (VALUE_PAIR *) NULL)
+		{
+			if (this_node == p)
+			{
+				break;
+			}
+			this_node = this_node->next;
+		}
+	}
+
+	/* add "b" at this_node */
+	vp = this_node->next;
+	this_node->next = b;
+
+	/* run to end of "b" and connect the rest of "a" */
+	while (b->next)
+		b = b->next;
+	b->next = vp;
+
+	return;
+}
+
+/*
+ * Function: rc_avpair_free
+ *
+ * Purpose: frees all value_pairs in the list
+ *
+ */
+
+void rc_avpair_free (VALUE_PAIR *pair)
+{
+	VALUE_PAIR     *next;
+
+	while (pair != (VALUE_PAIR *) NULL)
+	{
+		next = pair->next;
+		free (pair);
+		pair = next;
+	}
+}
+
+/*
+ * Function: rc_fieldcpy
+ *
+ * Purpose: Copy a data field from the buffer.  Advance the buffer
+ *          past the data field.
+ *
+ */
+
+static void rc_fieldcpy (char *string, char **uptr)
+{
+	char           *ptr;
+
+	ptr = *uptr;
+	if (*ptr == '"')
+	{
+		ptr++;
+		while (*ptr != '"' && *ptr != '\0' && *ptr != '\n')
+		{
+			*string++ = *ptr++;
+		}
+		*string = '\0';
+		if (*ptr == '"')
+		{
+			ptr++;
+		}
+		*uptr = ptr;
+		return;
+	}
+
+	while (*ptr != ' ' && *ptr != '\t' && *ptr != '\0' && *ptr != '\n' &&
+			*ptr != '=' && *ptr != ',')
+	{
+		*string++ = *ptr++;
+	}
+	*string = '\0';
+	*uptr = ptr;
+	return;
+}
+
+
+/*
+ * Function: rc_avpair_parse
+ *
+ * Purpose: parses the buffer to extract the attribute-value pairs.
+ *
+ * Returns: 0 = successful parse of attribute-value pair,
+ *	   -1 = syntax (or other) error detected.
+ *
+ */
+
+#define PARSE_MODE_NAME		0
+#define PARSE_MODE_EQUAL	1
+#define PARSE_MODE_VALUE	2
+#define PARSE_MODE_INVALID	3
+
+int rc_avpair_parse (char *buffer, VALUE_PAIR **first_pair)
+{
+	int             mode;
+	char            attrstr[AUTH_ID_LEN];
+	char            valstr[AUTH_ID_LEN];
+	DICT_ATTR      *attr = NULL;
+	DICT_VALUE     *dval;
+	VALUE_PAIR     *pair;
+	VALUE_PAIR     *link;
+	struct tm      *tm;
+	time_t          timeval;
+
+	mode = PARSE_MODE_NAME;
+	while (*buffer != '\n' && *buffer != '\0')
+	{
+		if (*buffer == ' ' || *buffer == '\t')
+		{
+			buffer++;
+			continue;
+		}
+
+		switch (mode)
+		{
+		    case PARSE_MODE_NAME:		/* Attribute Name */
+			rc_fieldcpy (attrstr, &buffer);
+			if ((attr =
+				rc_dict_findattr (attrstr)) == (DICT_ATTR *) NULL)
+			{
+				error("rc_avpair_parse: unknown attribute");
+				if (*first_pair) {
+					rc_avpair_free(*first_pair);
+					*first_pair = (VALUE_PAIR *) NULL;
+				}
+				return (-1);
+			}
+			mode = PARSE_MODE_EQUAL;
+			break;
+
+		    case PARSE_MODE_EQUAL:		/* Equal sign */
+			if (*buffer == '=')
+			{
+				mode = PARSE_MODE_VALUE;
+				buffer++;
+			}
+			else
+			{
+				error("rc_avpair_parse: missing or misplaced equal sign");
+				if (*first_pair) {
+					rc_avpair_free(*first_pair);
+					*first_pair = (VALUE_PAIR *) NULL;
+				}
+				return (-1);
+			}
+			break;
+
+		    case PARSE_MODE_VALUE:		/* Value */
+			rc_fieldcpy (valstr, &buffer);
+
+			if ((pair =
+				(VALUE_PAIR *) malloc (sizeof (VALUE_PAIR)))
+							== (VALUE_PAIR *) NULL)
+			{
+				novm("rc_avpair_parse");
+				if (*first_pair) {
+					rc_avpair_free(*first_pair);
+					*first_pair = (VALUE_PAIR *) NULL;
+				}
+				return (-1);
+			}
+			strcpy (pair->name, attr->name);
+			pair->attribute = attr->value;
+			pair->type = attr->type;
+			pair->vendorcode = attr->vendorcode;
+
+			switch (pair->type)
+			{
+
+			    case PW_TYPE_STRING:
+				strcpy (pair->strvalue, valstr);
+				pair->lvalue = strlen(valstr);
+				break;
+
+			    case PW_TYPE_INTEGER:
+				if (isdigit (*valstr))
+				{
+					pair->lvalue = atoi (valstr);
+				}
+				else
+				{
+					if ((dval = rc_dict_findval (valstr))
+							== (DICT_VALUE *) NULL)
+					{
+						error("rc_avpair_parse: unknown attribute value: %s", valstr);
+						if (*first_pair) {
+							rc_avpair_free(*first_pair);
+							*first_pair = (VALUE_PAIR *) NULL;
+						}
+						free (pair);
+						return (-1);
+					}
+					else
+					{
+						pair->lvalue = dval->value;
+					}
+				}
+				break;
+
+			    case PW_TYPE_IPADDR:
+				pair->lvalue = rc_get_ipaddr(valstr);
+				break;
+
+			    case PW_TYPE_DATE:
+				timeval = time (0);
+				tm = localtime (&timeval);
+				tm->tm_hour = 0;
+				tm->tm_min = 0;
+				tm->tm_sec = 0;
+				rc_str2tm (valstr, tm);
+#ifdef TIMELOCAL
+				pair->lvalue = (UINT4) timelocal (tm);
+#else	/* TIMELOCAL */
+				pair->lvalue = (UINT4) mktime (tm);
+#endif	/* TIMELOCAL */
+				break;
+
+			    default:
+				error("rc_avpair_parse: unknown attribute type %d", pair->type);
+				if (*first_pair) {
+					rc_avpair_free(*first_pair);
+					*first_pair = (VALUE_PAIR *) NULL;
+				}
+				free (pair);
+				return (-1);
+			}
+			pair->next = (VALUE_PAIR *) NULL;
+
+			if (*first_pair == (VALUE_PAIR *) NULL)
+			{
+				*first_pair = pair;
+			}
+			else
+			{
+				link = *first_pair;
+				while (link->next != (VALUE_PAIR *) NULL)
+				{
+					link = link->next;
+				}
+				link->next = pair;
+			}
+
+			mode = PARSE_MODE_NAME;
+			break;
+
+		    default:
+			mode = PARSE_MODE_NAME;
+			break;
+		}
+	}
+	return (0);
+}
+
+/*
+ * Function: rc_avpair_tostr
+ *
+ * Purpose: Translate an av_pair into two strings
+ *
+ * Returns: 0 on success, -1 on failure
+ *
+ */
+
+int rc_avpair_tostr (VALUE_PAIR *pair, char *name, int ln, char *value, int lv)
+{
+	DICT_VALUE     *dval;
+	char            buffer[32];
+	struct in_addr  inad;
+	unsigned char         *ptr;
+
+	*name = *value = '\0';
+
+	if (!pair || pair->name[0] == '\0') {
+		error("rc_avpair_tostr: pair is NULL or empty");
+		return (-1);
+	}
+
+	strncpy(name, pair->name, (size_t) ln);
+
+	switch (pair->type)
+	{
+	    case PW_TYPE_STRING:
+		lv--;
+		ptr = (unsigned char *) pair->strvalue;
+		while (*ptr != '\0')
+		{
+			if (!(isprint (*ptr)))
+			{
+				sprintf (buffer, "\\%03o", *ptr);
+				strncat(value, buffer, (size_t) lv);
+				lv -= 4;
+				if (lv < 0) break;
+			}
+			else
+			{
+				strncat(value, ptr, 1);
+				lv--;
+				if (lv < 0) break;
+			}
+			ptr++;
+		}
+		break;
+
+	    case PW_TYPE_INTEGER:
+		dval = rc_dict_getval (pair->lvalue, pair->name);
+		if (dval != (DICT_VALUE *) NULL)
+		{
+			strncpy(value, dval->name, (size_t) lv-1);
+		}
+		else
+		{
+			sprintf (buffer, "%ld", pair->lvalue);
+			strncpy(value, buffer, (size_t) lv);
+		}
+		break;
+
+	    case PW_TYPE_IPADDR:
+		inad.s_addr = htonl(pair->lvalue);
+		strncpy (value, inet_ntoa (inad), (size_t) lv-1);
+		break;
+
+	    case PW_TYPE_DATE:
+		strftime (buffer, sizeof (buffer), "%m/%d/%y %H:%M:%S",
+			  gmtime ((time_t *) & pair->lvalue));
+		strncpy(value, buffer, lv-1);
+		break;
+
+	    default:
+		error("rc_avpair_tostr: unknown attribute type %d", pair->type);
+		return (-1);
+		break;
+	}
+
+	return 0;
+}
+
+/*
+ * Function: rc_avpair_readin
+ *
+ * Purpose: get a sequence of attribute value pairs from the file input
+ *	    and make them into a list of value_pairs
+ *
+ */
+
+VALUE_PAIR *rc_avpair_readin(FILE *input)
+{
+	VALUE_PAIR *vp = NULL;
+	char buffer[1024], *q;
+
+	while (fgets(buffer, sizeof(buffer), input) != NULL)
+	{
+		q = buffer;
+
+		while(*q && isspace(*q)) q++;
+
+		if ((*q == '\n') || (*q == '#') || (*q == '\0'))
+			continue;
+
+		if (rc_avpair_parse(q, &vp) < 0) {
+			error("rc_avpair_readin: malformed attribute: %s", buffer);
+			rc_avpair_free(vp);
+			return NULL;
+		}
+	}
+
+	return vp;
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/buildreq.c tomato121/release/src/router/pppd/pppd/plugins/radius/buildreq.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/buildreq.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/buildreq.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,446 @@
+/*
+ * $Id: buildreq.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1997 Lars Fenneberg
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+
+unsigned char rc_get_seqnbr(void);
+
+/*
+ * Function: rc_get_nas_id
+ *
+ * Purpose: fills in NAS-Identifier or NAS-IP-Address in request
+ *
+ */
+
+int rc_get_nas_id(VALUE_PAIR **sendpairs)
+{
+	UINT4		client_id;
+	char *nasid;
+
+	nasid = rc_conf_str("nas_identifier");
+	if (strlen(nasid)) {
+		/*
+		 * Fill in NAS-Identifier
+		 */
+		if (rc_avpair_add(sendpairs, PW_NAS_IDENTIFIER, nasid, 0,
+				  VENDOR_NONE) == NULL)
+			return (ERROR_RC);
+
+		return (OK_RC);
+	  
+	} else {
+		/*
+		 * Fill in NAS-IP-Address
+		 */
+		if ((client_id = rc_own_ipaddress()) == 0)
+			return (ERROR_RC);
+
+		if (rc_avpair_add(sendpairs, PW_NAS_IP_ADDRESS, &client_id,
+				  0, VENDOR_NONE) == NULL)
+			return (ERROR_RC);
+	}
+
+	return (OK_RC);
+}
+
+/*
+ * Function: rc_buildreq
+ *
+ * Purpose: builds a skeleton RADIUS request using information from the
+ *	    config file.
+ *
+ */
+
+void rc_buildreq(SEND_DATA *data, int code, char *server, unsigned short port,
+		 int timeout, int retries)
+{
+	data->server = server;
+	data->svc_port = port;
+	data->seq_nbr = rc_get_seqnbr();
+	data->timeout = timeout;
+	data->retries = retries;
+	data->code = code;
+}
+
+/*
+ * Function: rc_guess_seqnbr
+ *
+ * Purpose: return a random sequence number
+ *
+ */
+
+static unsigned char rc_guess_seqnbr(void)
+{
+	return (unsigned char)(magic() & UCHAR_MAX);
+}
+
+/*
+ * Function: rc_get_seqnbr
+ *
+ * Purpose: generate a sequence number
+ *
+ */
+
+unsigned char rc_get_seqnbr(void)
+{
+	FILE *sf;
+	int tries = 1;
+	int seq_nbr, pos;
+	char *seqfile = rc_conf_str("seqfile");
+
+	if ((sf = fopen(seqfile, "a+")) == NULL)
+	{
+		error("rc_get_seqnbr: couldn't open sequence file %s: %s", seqfile, strerror(errno));
+		/* well, so guess a sequence number */
+		return rc_guess_seqnbr();
+	}
+
+	while (do_lock_exclusive(fileno(sf))!= 0)
+	{
+		if (errno != EWOULDBLOCK) {
+			error("rc_get_seqnbr: flock failure: %s: %s", seqfile, strerror(errno));
+			fclose(sf);
+			return rc_guess_seqnbr();
+		}
+		tries++;
+		if (tries <= 10)
+			rc_mdelay(500);
+		else
+			break;
+	}
+
+	if (tries > 10) {
+		error("rc_get_seqnbr: couldn't get lock after %d tries: %s", tries-1, seqfile);
+		fclose(sf);
+		return rc_guess_seqnbr();
+	}
+
+	pos = ftell(sf);
+	rewind(sf);
+	if (fscanf(sf, "%d", &seq_nbr) != 1) {
+		if (pos != ftell(sf)) {
+			/* file was not empty */
+			error("rc_get_seqnbr: fscanf failure: %s", seqfile);
+		}
+		seq_nbr = rc_guess_seqnbr();
+	}
+
+	rewind(sf);
+	ftruncate(fileno(sf),0);
+	fprintf(sf,"%d\n", (seq_nbr+1) & UCHAR_MAX);
+
+	fflush(sf); /* fflush because a process may read it between the do_unlock and fclose */
+
+	if (do_unlock(fileno(sf)) != 0)
+		error("rc_get_seqnbr: couldn't release lock on %s: %s", seqfile, strerror(errno));
+
+	fclose(sf);
+
+	return (unsigned char)seq_nbr;
+}
+
+/*
+ * Function: rc_auth
+ *
+ * Purpose: Builds an authentication request for port id client_port
+ *	    with the value_pairs send and submits it to a server
+ *
+ * Returns: received value_pairs in received, messages from the server in msg
+ *	    and 0 on success, negative on failure as return value
+ *
+ */
+
+int rc_auth(UINT4 client_port, VALUE_PAIR *send, VALUE_PAIR **received,
+	    char *msg, REQUEST_INFO *info)
+{
+    SERVER *authserver = rc_conf_srv("authserver");
+
+    if (!authserver) {
+	return (ERROR_RC);
+    }
+    return rc_auth_using_server(authserver, client_port, send, received,
+				msg, info);
+}
+
+/*
+ * Function: rc_auth_using_server
+ *
+ * Purpose: Builds an authentication request for port id client_port
+ *	    with the value_pairs send and submits it to a server.  You
+ *          explicitly supply a server list.
+ *
+ * Returns: received value_pairs in received, messages from the server in msg
+ *	    and 0 on success, negative on failure as return value
+ *
+ */
+
+int rc_auth_using_server(SERVER *authserver,
+			 UINT4 client_port,
+			 VALUE_PAIR *send,
+			 VALUE_PAIR **received,
+			 char *msg, REQUEST_INFO *info)
+{
+	SEND_DATA       data;
+	int		result;
+	int		i;
+	int		timeout = rc_conf_int("radius_timeout");
+	int		retries = rc_conf_int("radius_retries");
+
+	data.send_pairs = send;
+	data.receive_pairs = NULL;
+
+	/*
+	 * Fill in NAS-IP-Address or NAS-Identifier
+	 */
+
+	if (rc_get_nas_id(&(data.send_pairs)) == ERROR_RC)
+	    return (ERROR_RC);
+
+	/*
+	 * Fill in NAS-Port
+	 */
+
+	if (rc_avpair_add(&(data.send_pairs), PW_NAS_PORT, &client_port, 0, VENDOR_NONE) == NULL)
+		return (ERROR_RC);
+
+	result = ERROR_RC;
+	for(i=0; (i<authserver->max) && (result != OK_RC) && (result != BADRESP_RC)
+		; i++)
+	{
+		if (data.receive_pairs != NULL) {
+			rc_avpair_free(data.receive_pairs);
+			data.receive_pairs = NULL;
+		}
+		rc_buildreq(&data, PW_ACCESS_REQUEST, authserver->name[i],
+			    authserver->port[i], timeout, retries);
+
+		result = rc_send_server (&data, msg, info);
+	}
+
+	*received = data.receive_pairs;
+
+	return result;
+}
+
+/*
+ * Function: rc_auth_proxy
+ *
+ * Purpose: Builds an authentication request
+ *	    with the value_pairs send and submits it to a server.
+ *	    Works for a proxy; does not add IP address, and does
+ *	    does not rely on config file.
+ *
+ * Returns: received value_pairs in received, messages from the server in msg
+ *	    and 0 on success, negative on failure as return value
+ *
+ */
+
+int rc_auth_proxy(VALUE_PAIR *send, VALUE_PAIR **received, char *msg)
+{
+	SEND_DATA       data;
+	int		result;
+	int		i;
+	SERVER		*authserver = rc_conf_srv("authserver");
+	int		timeout = rc_conf_int("radius_timeout");
+	int		retries = rc_conf_int("radius_retries");
+
+	data.send_pairs = send;
+	data.receive_pairs = NULL;
+
+	result = ERROR_RC;
+	for(i=0; (i<authserver->max) && (result != OK_RC) && (result != BADRESP_RC)
+		; i++)
+	{
+		if (data.receive_pairs != NULL) {
+			rc_avpair_free(data.receive_pairs);
+			data.receive_pairs = NULL;
+		}
+		rc_buildreq(&data, PW_ACCESS_REQUEST, authserver->name[i],
+			    authserver->port[i], timeout, retries);
+
+		result = rc_send_server (&data, msg, NULL);
+	}
+
+	*received = data.receive_pairs;
+
+	return result;
+}
+
+
+/*
+ * Function: rc_acct_using_server
+ *
+ * Purpose: Builds an accounting request for port id client_port
+ *	    with the value_pairs send.  You explicitly supply server list.
+ *
+ * Remarks: NAS-Identifier/NAS-IP-Address, NAS-Port and Acct-Delay-Time get
+ *	    filled in by this function, the rest has to be supplied.
+ */
+
+int rc_acct_using_server(SERVER *acctserver,
+			 UINT4 client_port,
+			 VALUE_PAIR *send)
+{
+	SEND_DATA       data;
+	VALUE_PAIR	*adt_vp;
+	int		result;
+	time_t		start_time, dtime;
+	char		msg[4096];
+	int		i;
+	int		timeout = rc_conf_int("radius_timeout");
+	int		retries = rc_conf_int("radius_retries");
+
+	data.send_pairs = send;
+	data.receive_pairs = NULL;
+
+	/*
+	 * Fill in NAS-IP-Address or NAS-Identifier
+	 */
+
+	if (rc_get_nas_id(&(data.send_pairs)) == ERROR_RC)
+	    return (ERROR_RC);
+
+	/*
+	 * Fill in NAS-Port
+	 */
+
+	if (rc_avpair_add(&(data.send_pairs), PW_NAS_PORT, &client_port, 0, VENDOR_NONE) == NULL)
+		return (ERROR_RC);
+
+	/*
+	 * Fill in Acct-Delay-Time
+	 */
+
+	dtime = 0;
+	if ((adt_vp = rc_avpair_add(&(data.send_pairs), PW_ACCT_DELAY_TIME, &dtime, 0, VENDOR_NONE)) == NULL)
+		return (ERROR_RC);
+
+	start_time = time(NULL);
+	result = ERROR_RC;
+	for(i=0; (i<acctserver->max) && (result != OK_RC) && (result != BADRESP_RC)
+		; i++)
+	{
+		if (data.receive_pairs != NULL) {
+			rc_avpair_free(data.receive_pairs);
+			data.receive_pairs = NULL;
+		}
+		rc_buildreq(&data, PW_ACCOUNTING_REQUEST, acctserver->name[i],
+			    acctserver->port[i], timeout, retries);
+
+		dtime = time(NULL) - start_time;
+		rc_avpair_assign(adt_vp, &dtime, 0);
+
+		result = rc_send_server (&data, msg, NULL);
+	}
+
+	rc_avpair_free(data.receive_pairs);
+
+	return result;
+}
+
+/*
+ * Function: rc_acct
+ *
+ * Purpose: Builds an accounting request for port id client_port
+ *	    with the value_pairs send
+ *
+ * Remarks: NAS-Identifier/NAS-IP-Address, NAS-Port and Acct-Delay-Time get
+ *	    filled in by this function, the rest has to be supplied.
+ */
+
+int rc_acct(UINT4 client_port, VALUE_PAIR *send)
+{
+    SERVER *acctserver = rc_conf_srv("acctserver");
+    if (!acctserver) return (ERROR_RC);
+
+    return rc_acct_using_server(acctserver, client_port, send);
+}
+
+/*
+ * Function: rc_acct_proxy
+ *
+ * Purpose: Builds an accounting request with the value_pairs send
+ *
+ */
+
+int rc_acct_proxy(VALUE_PAIR *send)
+{
+	SEND_DATA       data;
+	int		result;
+	char		msg[4096];
+	int		i;
+	SERVER		*acctserver = rc_conf_srv("authserver");
+	int		timeout = rc_conf_int("radius_timeout");
+	int		retries = rc_conf_int("radius_retries");
+
+	data.send_pairs = send;
+	data.receive_pairs = NULL;
+
+	result = ERROR_RC;
+	for(i=0; (i<acctserver->max) && (result != OK_RC) && (result != BADRESP_RC)
+		; i++)
+	{
+		if (data.receive_pairs != NULL) {
+			rc_avpair_free(data.receive_pairs);
+			data.receive_pairs = NULL;
+		}
+		rc_buildreq(&data, PW_ACCOUNTING_REQUEST, acctserver->name[i],
+			    acctserver->port[i], timeout, retries);
+
+		result = rc_send_server (&data, msg, NULL);
+	}
+
+	rc_avpair_free(data.receive_pairs);
+
+	return result;
+}
+
+/*
+ * Function: rc_check
+ *
+ * Purpose: ask the server hostname on the specified port for a
+ *	    status message
+ *
+ */
+
+int rc_check(char *host, unsigned short port, char *msg)
+{
+	SEND_DATA       data;
+	int		result;
+	UINT4		service_type;
+	int		timeout = rc_conf_int("radius_timeout");
+	int		retries = rc_conf_int("radius_retries");
+
+	data.send_pairs = data.receive_pairs = NULL;
+
+	/*
+	 * Fill in NAS-IP-Address or NAS-Identifier,
+         * although it isn't neccessary
+	 */
+
+	if (rc_get_nas_id(&(data.send_pairs)) == ERROR_RC)
+	    return (ERROR_RC);
+
+	/*
+	 * Fill in Service-Type
+	 */
+
+	service_type = PW_ADMINISTRATIVE;
+	rc_avpair_add(&(data.send_pairs), PW_SERVICE_TYPE, &service_type, 0, VENDOR_NONE);
+
+	rc_buildreq(&data, PW_STATUS_SERVER, host, port, timeout, retries);
+	result = rc_send_server (&data, msg, NULL);
+
+	rc_avpair_free(data.receive_pairs);
+
+	return result;
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/clientid.c tomato121/release/src/router/pppd/pppd/plugins/radius/clientid.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/clientid.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/clientid.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,121 @@
+/*
+ * $Id: clientid.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996,1997 Lars Fenneberg
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+
+struct map2id_s {
+	char *name;
+	UINT4 id;
+
+	struct map2id_s *next;
+};
+
+static struct map2id_s *map2id_list = NULL;
+
+/*
+ * Function: rc_read_mapfile
+ *
+ * Purpose: Read in the ttyname to port id map file
+ *
+ * Arguments: the file name of the map file
+ *
+ * Returns: zero on success, negative integer on failure
+ */
+
+int rc_read_mapfile(char *filename)
+{
+	char buffer[1024];
+	FILE *mapfd;
+	char *c, *name, *id, *q;
+	struct map2id_s *p;
+	int lnr = 0;
+
+	if ((mapfd = fopen(filename,"r")) == NULL)
+	{
+		error("rc_read_mapfile: can't read %s: %s", filename, strerror(errno));
+		return (-1);
+	}
+
+#define SKIP(p) while(*p && isspace(*p)) p++;
+
+	while (fgets(buffer, sizeof(buffer), mapfd) != NULL)
+	{
+		lnr++;
+
+		q = buffer;
+
+		SKIP(q);
+
+		if ((*q == '\n') || (*q == '#') || (*q == '\0'))
+			continue;
+
+		if (( c = strchr(q, ' ')) || (c = strchr(q,'\t'))) {
+
+			*c = '\0'; c++;
+			SKIP(c);
+
+			name = q;
+			id = c;
+
+			if ((p = (struct map2id_s *)malloc(sizeof(*p))) == NULL) {
+				novm("rc_read_mapfile");
+				return (-1);
+			}
+
+			p->name = strdup(name);
+			p->id = atoi(id);
+			p->next = map2id_list;
+			map2id_list = p;
+
+		} else {
+
+			error("rc_read_mapfile: malformed line in %s, line %d", filename, lnr);
+			return (-1);
+
+		}
+	}
+
+#undef SKIP
+
+	fclose(mapfd);
+
+	return 0;
+}
+
+/*
+ * Function: rc_map2id
+ *
+ * Purpose: Map ttyname to port id
+ *
+ * Arguments: full pathname of the tty
+ *
+ * Returns: port id, zero if no entry found
+ */
+
+UINT4 rc_map2id(char *name)
+{
+	struct map2id_s *p;
+	char ttyname[PATH_MAX];
+
+	*ttyname = '\0';
+	if (*name != '/')
+		strcpy(ttyname, "/dev/");
+
+	strncat(ttyname, name, sizeof(ttyname));
+
+	for(p = map2id_list; p; p = p->next)
+		if (!strcmp(ttyname, p->name)) return p->id;
+
+	warn("rc_map2id: can't find tty %s in map database", ttyname);
+
+	return 0;
+}
